<?php
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
// Class to connect to the LDAP server and authenticate a user
// Nearly all of this comes from Denis Roy's Foundation DB code
class auth_ldap {
	var $LdapUrl;
	var $LdapDn;
	function auth_ldap( $context ) {
		$this->LdapUrl 	= $context->get("ldap-url");
		$this->LdapDn	= "ou=people,dc=eclipse,dc=org";
	}
	function authenticate($_user_id, $_password)
	{
		$ds = ldap_connect($this->LdapUrl);
		ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3);

		if ($ds) {
			$bind_uid = "uid=" . $_user_id . "," . $this->LdapDn;

   			$r = @ldap_bind($ds, $bind_uid, $_password);


   			if($r) {
   				return true;
   			}
   			else {
   				return false;
   			}
   			ldap_close($ds);
		}
		else {
   			return false;
		}
	return true;

	}
}
?>
