<?php
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
// +==================================================================+
// | Immediate cron script to support once-per-minute tasks           |
// | Run as (cd myfoundation/classes; ./immediatecron.php) from cron  |
// +==================================================================+

// +--------------------------------------------+
// | RETURNS:                                   |
// |    5 - on process lock failure to write    |
// |    6 - on process lock failure to remove   |
// |    0 - on success                          |
// +--------------------------------------------+

$cwd = getcwd();
$cwd = preg_replace( "/\\\\/", "/", $cwd );
$tmp = strrpos( $cwd, "/");
if( substr( $cwd, $tmp ) != "/myfoundation") {
        $cwd = substr( $cwd, 0, $tmp );
}
$GLOBALS['ROOT_DIRECTORY'] = $cwd;
$GLOBALS['CLASSES_DIRECTORY'] = $cwd . "/classes/";
$GLOBALS['COMPONENTS_DIRECTORY'] = $cwd . "/components/";
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "context.class.php" );
require( $GLOBALS['CLASSES_DIRECTORY'] . "create-context.php" );
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "immediatecron.class.php");
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "functions.php");

// Make sure we're not called from the web server even on dev machines
if(!isset($argc)) {
	echo "Permission denied";
	exit;
}

ini_set('include_path', ini_get('include_patch') . $GLOBALS['ROOT_DIRECTORY'] .
'/pear');

if(!check_process_lock("immediate", $context)) {
	echo "Error getting process lock file.\n";
	exit(5); // A number to tell any shell scripts what happened.
}

$cron = new SendImmediateEmails();
$cron->send_emails($context);

if(!remove_process_lock("immediate", $context)) {
	echo "Error removing process lock file.\n";
	exit(6); // A number to tell any shell scripts what happened.
}

?>
