<?php
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/

echo "[disabling foreign key constraint checking] <br>\n";
$result = foundation_sql("SET FOREIGN_KEY_CHECKS = 0");

echo "SYS_Countries$suffix <br>\n";
foundation_sql("DELETE FROM SYS_Countries$suffix");
$result = foundation_sql( "INSERT INTO SYS_Countries$suffix ( CCode, en_Description ) VALUES
( 'ca', 'Canada' ),
( 'us', 'United States' ),
( 'lm', 'Long Country Name That Causes Scrolling When Not Shortened By Our Clever Display System');");

echo "SYS_Relations$suffix <br>\n";
foundation_sql("DELETE FROM SYS_Relations$suffix");
$result = foundation_sql( "INSERT INTO SYS_Relations$suffix ( Relation, Description, IsActive, Type ) VALUES
( 'CM', 'Committer', 1, 'PR'),
( 'EA', 'Appointed - Architecture Council', 1, 'GE'),
( 'EP', 'Appointed - Planning Council', 1, 'GE'),
( 'ER', 'Appointed - Requirements Council', 1, 'GE'),
( 'AC', 'Architecture Council', 1, 'OC'),
( 'BR', 'Board Rep', 1, 'OC'),
( 'PC', 'Planning Council', 1, 'OC'),
( 'RC', 'Requirements Council', 1, 'OC'),
( 'RA', 'Architecture Council Representative', 1, 'PR'),
( 'RP', 'Planning Council Representative', 1, 'PR'),
( 'RR', 'Requirements Council Representative', 1, 'PR'),
( 'PM', 'PMC Member', 1, 'PR'),
( 'PD', 'PMC Lead', 1, 'PR'),
( 'PL', 'Project Lead', 1, 'PR'),
( 'EL', 'Eclipse Legal', 1, 'GE'),
( 'EM', 'Eclipse Membership', 1, 'GE'),
( 'CR', 'Company Representative', 1, 'OC'),
( 'DE', 'Delegate', 1, 'OC'),
( 'PORTL', 'Eclipse Portal Czar', 1, 'GE'),
( 'POLL', 'Eclipse Pollmeister', 1, 'GE'),
( 'MEETG', 'Eclipse Meeting Scheduler', 1, 'GE'),
( 'WEBM', 'WebMaster', 1, 'GE')");

echo "People$suffix <br>\n";
foundation_sql("DELETE FROM People$suffix");
$result = foundation_sql("INSERT INTO People$suffix ( PersonID, FName, LName, Email, Phone ) VALUES
( 'developer1', 'Alex', 'Developer', 'developer1@example.com', '555-1212'),
( 'developer2', 'Lucy', 'Programmer', 'developer2@example.com', '555-1212'),
( 'developer3', 'Molly', 'Code', 'developer3@example.com', '555-1212'),
( 'developer4', 'Tyro', 'Newbie', 'developer4@example.com', '555-1212'),
( 'nancynew', 'Nancy', 'New', 'nancynew@example.com', '555-1212'),
( 'pmclead', 'Ben', 'Leader', 'pmclead@example.com', '555-1212'),
( 'big1', 'Samantha', 'Strategic', 'big1@example.com', '555-1212'),
( 'big2', 'Matthew', 'ExecVP', 'big2@example.com', '555-1212'),
( 'big3', 'Hannah', 'HardWorker', 'big3@example.com', '555-1212'),
( 'big4', 'Anthony', 'Architect', 'big4@example.com', '555-1212'),
( 'big5', 'Elizabeth', 'Editor', 'big5@example.com', '555-1212'),
( 'small1', 'Andrew', 'AddIn', 'small1@example.com', '555-1212'),
( 'small2', 'Angela', 'AddIn', 'small2@example.com', '555-1212'),
( 'medium1', 'Monsieur', 'Moderately', 'medium1@example.com', '555-1212'),
( 'pmcmember', 'William', 'Committee', 'pmcmember@example.com', '555-1212'),
( 'emolegal', 'Grace', 'Legal', 'emolegal@example.com', '555-1212'),
( 'emomembership', 'Dudley', 'Do-Right', 'emomembership@example.com', '555-1212'),
( 'emoportal', 'Portal', 'People', 'emoportal@example.com', '555-1212'),
( 'emocouncil', 'Hello', 'MyNameIs', 'emocouncil@example.com', '555-1212'),
( 'webmaster', 'Wally', 'Webmaster', 'webmaster@example.com', '555-1212'),
( 'sally4th', 'Sally', 'Forth', 's4@example.com', '555-1212'),
( 'portly', 'Pascal', 'Portly', 'pp@example.com', '555-1212'),
( 'oldmetal', 'Tran', 'For', 'fortran@example.com', '555-1212'),
( 'litha', 'Litha', 'Lisp', 'litha@example.com', '555-1212'),
( 'malcolm', 'Malcolm', 'Member', 'malcolmmember@example.com', '555-1212');");

// Member auth information for Malcolm Member
$result = foundation_sql("UPDATE People$suffix SET IsMember = TRUE, MemberPasswd = '" . sha1("%L#dvqq" . "mloclam") . "' WHERE PersonID = 'malcolm';");

echo "PeopleAddresses$suffix <br>\n";
foundation_sql("DELETE FROM PeopleAddresses$suffix");
$result = foundation_sql( "INSERT INTO PeopleAddresses$suffix ( PersonID, AddressID, Address1, City, ProvStateRegion, PostalCode, CCode ) VALUES
( 'developer1', 1, 'North', 'Busytown', 'Oregon', '97204', (SELECT CCode FROM SYS_Countries$suffix WHERE CCode = 'us')),
( 'developer2', 1, 'West', 'Big City', 'Washington', '98103', (SELECT CCode FROM SYS_Countries$suffix WHERE CCode = 'us')),
( 'developer2', 2, 'Street', 'Suburb', 'Washington', '98052', (SELECT CCode FROM SYS_Countries$suffix WHERE CCode = 'us')),
( 'developer3', 2, 'North East', 'Dullsville', 'Ohio', '45101', (SELECT CCode FROM SYS_Countries$suffix WHERE CCode = 'us')),
( 'big2', 1, '45 Frozen Lane', 'Cold Lake', 'Ontario', 'K2G 3K3', (SELECT CCode FROM SYS_Countries$suffix WHERE CCode = 'ca'));");

echo "Projects$suffix <br>\n";
foundation_sql("DELETE FROM Projects$suffix");
$result = foundation_sql( "INSERT INTO Projects$suffix ( ProjectID, Description, Level, ParentProjectID, DateActive ) VALUES
( 'technology.foo', 'technology.foo project', 1, 'technology', '2005-12-10' ),
( 'technology', 'technology project', 2, 'root', '2005-12-10' ),
( 'technology.bar', 'technology.bar project', 2, 'technology', '2005-12-10' ),
( 'technology.wish', 'technology.wish project', 2, 'technology', '2005-12-10' ),
( 'technology.single', 'technology.single project', 2, 'technology', '2005-12-10');");

echo "PeopleProjects$suffix <br>\n";
foundation_sql("DELETE FROM PeopleProjects$suffix");
$result = foundation_sql( "INSERT INTO PeopleProjects$suffix ( PersonID, ProjectID, Relation, ActiveDate, InactiveDate ) VALUES
( 'developer1', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.foo'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null ),
( 'developer1', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.foo'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'PL'), '2005-12-10', null ),
( 'developer1', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.wish'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'PL'), '2005-12-10', null ),
( 'pmclead', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'PD'), '2005-12-10', null ),
( 'pmclead', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'PM'), '2005-12-10', null ),
( 'oldmetal', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'RP'), '2005-12-10', null ),
( 'pmcmember', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'PM'), '2005-12-10', null ),
( 'developer1', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.bar'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null ),
( 'developer3', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.bar'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null ),
( 'developer2', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.foo'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null ),
( 'litha', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.foo'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'RP'), '2005-12-10', null ),
( 'big4', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.foo'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', '2005-12-12' ),
( 'big5', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null ),
( 'developer1', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.wish'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null ),
( 'developer2', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.wish'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null ),
( 'developer3', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.wish'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null ),
( 'developer4', (SELECT ProjectID FROM Projects$suffix WHERE ProjectID = 'technology.single'), (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'CM'), '2005-12-10', null );");

echo "PeopleRelations$suffix <br>\n";
foundation_sql("DELETE FROM PeopleRelations$suffix");
$result = foundation_sql( "INSERT INTO PeopleRelations$suffix ( PersonID, Relation, EntryDate ) VALUES
( 'developer3', (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'POLL'), '2005-12-10' ),
( 'webmaster', (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'WEBM'), '2005-12-10' ),
( 'emoportal', (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'PORTL'), '2005-12-10' ),
( 'emolegal', (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'EL'), '2005-12-10' ),
( 'sally4th', (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'EP'), '2005-12-10' ),
( 'emocouncil', (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'MEETG'), '2005-12-10' ),
( 'emomembership', (SELECT Relation FROM SYS_Relations$suffix WHERE Relation = 'EM'), '2005-12-10' );");

echo "[enabling foreign key constraint checking] <br>\n";
$result = foundation_sql("SET FOREIGN_KEY_CHECKS = 1");
?>
