<?php
require_once( "../classes/external_entry_point.php");
external_entry(false);
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
if(!isset($_SESSION['portaluser'])) {
	?>
	<font color=red>No logged in user</font>
	<?php
	exit();
}
/*
 * Separate the id into the class name and object identifier
 */
$fullid = $_REQUEST['id'];
preg_match( "/([A-Za-z0-9_\-\.!]+)/", $fullid, $matches );
$fullid = $matches[1];
$i = strpos( $fullid, "." );
$componentname = substr( $fullid, 0, $i );
$id = substr( $fullid, $i+1 );
$i = strpos( $id, "." );
$classname = substr( $id, 0, $i );
$id = substr( $id, $i+1 );

/*
 * Load the factory class and instantiate the object.
 * The factory takes care of privacy issues and thus if
 * the current context is not allowed to instantiate this
 * object, we get back null.
 */
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "ifactory.class.php");
require_once( $GLOBALS['COMPONENTS_DIRECTORY'] . "" . $componentname . "/factory.php" );
$factoryclass = $componentname . "_Factory";
$factory = new $factoryclass();
$object = $factory->getObjectForId( $classname, $id, $context );
if( $object === null ) {
	// perhaps change this message to broken-refresh icon
    echo "Can't find $componentname / $classname with id $id";
    exit();
 }

if($_SESSION['portaluser'] == 'anonymous') {
	if(!$object->anonymous_allowed()) {
		echo "<font color='red'>Illegal use of anonymous login</font>";
		exit();
	}
}

/*
 * Untaint the requested action. We have to be careful because
 * the outside world could pass in any string at all and we
 * don't want them to execute just any method. So we first filter
 * the string to a limited set of words and then we append on a
 * suffix; finally it is ready for use.
 */
$action = $_REQUEST['action'];
preg_match( "/([a-zA-Z0-9]+)/", $action, $matches );
$action = $matches[1];
$action = $action . "_action";
/*
 * Untaint the requested parameter. Again, we need to be careful.
 */
$param = null;
if( $_REQUEST['param']) {
	$param = $_REQUEST['param'];
	preg_match( "/([a-zA-Z0-9\.\-_]+)/", $param, $matches );
	$param = $matches[1];
}
/*
 * Call the requested method.
 */
$methods = get_class_methods ($object);
if (in_array ($action, $methods)) {
	$object->$action( $context, $param );
} else {
  echo "Can't find $action in $componentname";
}
?>
