<?php
// EXEMPT from requirement to have external-entry-point
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
require_once( "../classes/external_entry_point.php"); // included for globals and disabled check, but not for context or login requirement
require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/app.class.php");	
require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/nav.class.php"); 	
require_once($_SERVER['DOCUMENT_ROOT'] . "/eclipse.org-common/system/menu.class.php"); 	
$App 	= new App();	$Nav	= new Nav();	$Menu 	= new Menu();		include($App->getProjectCommon());

$pageTitle 		= "Login to My Foundation";
$pageKeywords	= "";
$pageAuthor		= "";

$extraHtmlHeaders = "<link rel=\"stylesheet\" 
      type=\"text/css\" 
      href=\"images/portal.css\"/>
	";
$App->AddExtraHtmlHeader($extraHtmlHeaders);

ob_start();
?>
    <div id="maincontent">
	<div id="midcolumn">

    	<div class="component">
        <div class="title">
            Login to the My Foundation Portal
        </div>
        <div class="login">
    	<form method="POST">
    	<table><?php
    	if( $GLOBALS['MYFOUNDATION_LOGIN_ERROR'] ) {
    		?><tr><td colspan=2><b><font color=#FF0000><?= $GLOBALS['MYFOUNDATION_LOGIN_ERROR'] ?></font></b></td></tr><?php
    	}
    	?>
    	<tr>
    		<td>Committer Login or<br>Member Username:</td>
    		<td><input type="text" size="30" name="user" value=""></td>
    	</tr>
    	<tr>
    		<td>Password:</td>
    		<td><input type="password" size="30" name="password" value=""></td>
    	</tr>
    	<tr>
    		<td><input type="submit" name="Submit" value="Submit"></td>
    	</tr>
    	</table>
    	</form>
        </div>
    	</div>

  <div style="margin: 0 0 0 1em">
  <h2>What is the MyFoundation Portal?</h2>
  <p>
  The portal provides a convenient single page summary of your
  relationship with the Eclipse Foundation such as your contact
  address, phone, and email as well as your role in ecosystem and/or
  projects. The portal also provides an easy interface to relevant
  processes and workflows including nominating and electing new
  committers, scheduling project reviews, and so on.</p>
  <p>
  Currently the portal
  is available to <b>Eclipse Members</b> and <b>Eclipse Committers</b>. 
  Members are members of the Eclipse Foundation; Committers
  are developers on the <a href="http://www.eclipse.org/projects/">Eclipse Projects</a> who have been elected to committer 
  status by their peers. For information
  on becoming an Eclipse Member, please see the <a href="http://www.eclipse.org/membership/">Membership web pages</a>.
  </p>
  <h2>What is available on the MyFoundation Portal?</h2>
  <p>The <a href="https://dev.eclipse.org/portal/myfoundation/tests/breakdown.php">complete set of portal use-cases</a>
  is open and transparent
  and available to everyone (i.e., not just Members and Committers;
  everyone - including you).
  </p>
  <p>Each portal process includes open and transparent documentation of the 
  entire process. For example, consider the 
  <a href="https://dev.eclipse.org/portal/myfoundation/tests/swim.php?file=finished/committer_election.txt">complete 
  committer nomination and election process</a>: the 
  <a href="https://dev.eclipse.org/portal/myfoundation/tests/swim.php?file=finished/committer_election.txt">documentation</a>
  explains the roles and responsibilities of each participant (the candidate, the voters, the PMC, the EMO, etc.)
  This openness and transparency, plus the 24x7 availability of the MyFoundation portal are some of the main
  benefits of the portal.</p>
  </div>
  </div><!-- midcolumn -->
</div><!-- maincontent -->
<?php
	# Paste your HTML content between the EOHTML markers!	
	$html = ob_get_contents();
	ob_end_clean();

	# Generate the web page
	$App->generatePage($theme, $Menu, $Nav, $pageAuthor, $pageKeywords, $pageTitle, $html);
?>
