#!/usr/bin/perl
#*******************************************************************************
#* Copyright (c) 2006-2007 Eclipse Foundation
#* All rights reserved. This program and the accompanying materials
#* are made available under the terms of the Eclipse Public License v1.0
#* which accompanies this distribution, and is available at
#* http://www.eclipse.org/legal/epl-v10.html
#*
#* Contributors:
#*    Bjorn Freeman-Benson - initial API and implementation
#*    Ward Cunningham - initial API and implementation
#*    Karl Mathias - initial API and implementation
#*******************************************************************************/

# THIS CODE IS USED IN STAGING, BUT all.php IS USED IN PRODUCTION/DEV
# UPDATES HERE NEED TO BE REFLECTED THERE

use strict;
use LWP;
use FileHandle;
use POSIX qw(uname);
$|=1;

die("usage: cd tests; ./all.pl 'http://dash.eclipse.org/-bfreeman/myfoundation/tests'\n") unless @ARGV == 1;
my $path = pop(@ARGV);
my $browser = LWP::UserAgent->new;

my ($ostype) = uname();

# Read in staging username and password if there is a file there to read from
# File format is one line:
# username:password
if (-r $ENV{'HOME'} . "/web_credentials") {
        my $fh = new FileHandle("< " . $ENV{'HOME'} . "/web_credentials");
        my @credentials = split(":", $fh->getline());
        chomp($credentials[1]);
        $fh->close();
        $browser->credentials(
                'www.eclipsecon.org:8084',
                'Restricted Area',
                $credentials[0] => $credentials[1]
        );
}

my $failed = 0;
my @list;
if( $ostype eq 'Windows NT' ) {
	@list = split (/\n/,`dir /b scripts\\finished\\*.txt`);
	@list = map "finished\\$_", @list;
} else {
	@list = split (/\n/,`cd scripts; ls finished/*.txt`);
}
for (@list) {
	my $result = $browser->get($path . "/run.php?file=" . $_) or
			die "Can't open connection to $path";
	my $report = $result->decoded_content();
	my $status = !$report ? 'Missing' : ($report =~ /<!-- Test Passed -->/) ? 'Passed' : 'FAIL  ';
	if($status eq "FAIL  ") { $failed++; }
	print "$status: $_\n";
}
exit($failed);
