<?php
require_once( "../classes/external_entry_point.php");
external_entry( false, "Process Explorer");
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
require_once($GLOBALS['CLASSES_DIRECTORY'] . "functions.php" ); 
require_once("test-functions.php");
?>

<p>
<?php

$component = $_REQUEST['component'];
$class = $_REQUEST['class'];
$action = $_REQUEST['action'];
switch ($action) {
	case "edit":
		$default = "Press <b>edit</b> to make modifications to this object.";
		break;
	case "revert":
		$default = "Press <b>revert</b> to return to the default display.";
		break;
	default:
		$default = ""; // "No explaination for <b>$action</b> recorded at this time.";
		break;
}
$qualified = ($component != $class) ? "<b>$class</b> class within the" : "";
echo "<font color=gray><p>You are exploring the <b>$action</b> action of the $qualified <b>$component</b> component.</p></font>";
$local_explore = "../components/$component/explore.php";
if (is_file($local_explore)) {
	echo "<blockquote>";
	include($local_explore);
	echo "</blockquote>";
}

echo "<p><font color=gray>This behavior has been tested in the following use cases:</font><ul>";

$tmp = $context->get("indices_directory");
$previous = false;
$lines = array();
$count = 0;
foreach (files($tmp) as $file) {
        if (substr($file, -8) != '.explore' && substr($file, -6) != '.email') continue;
        foreach (file("$tmp/$file") as $line) {
                $fields = preg_split('/\t/', trim($line));
                if (count($fields) < 5) continue;
                $test = $fields[0];
                $line = $fields[1];
                $comp = $fields[2];
                $clas = $fields[3];
                $act = $fields[4];
                if ($comp != $component) continue;
		if ($clas != $class) continue;
		if ($act != $action) continue;
		$count++;
		if ($test != $previous) {
			emit ($previous, $lines);
			$lines = array();
		}
		$previous = $test;
		$lines[] = $line;
        }
}
emit ($previous, $lines);

if ($count == 0)
	echo "<li><font color=gray><i>None Found</i></font>";


function emit ($test, $lines) {
	if (!$test) return;
	$list = join(',', $lines);
	$count = count($lines);
	$various = $count>1 ? "($count places)" : "";
        $url = "../tests/swim.php?file=$test&lines=$list";
        echo "<li> <a href=$url>" . test_title($test) . "</a> $various";
}

?>
</ul>
</p>

<font color=gray>
<p> This page offers a brief explaination of a specific portal action. This page also exposes the exact use cases under which the portal's behavior for this action has been tested.</p> 

<p>Should you follow the links above, you will see reports generated from the installed code applied to pretend users. This provides exceptional transparency of our automated processes while protecting personal information about our users. 
See <a href=../tests/breakdown.php>Use Case Breakdown</a> for more actions that can be explored. </p>
</font>
