<?php
require_once( "../classes/external_entry_point.php");
external_entry( false, "Portal Use Cases" );
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
require_once($GLOBALS['CLASSES_DIRECTORY'] . "functions.php" );
require_once( "test-functions.php" );


$tmp = $context->get("indices_directory");

// list components used in order of first occurence

function components_used ( $filename ) {
	$comps = "";
	$result = array();
        foreach (file($filename) as $line) {
		if (preg_match( "/(find|component)\s*\(\s*(\'|\")(\w+)/", $line, $match)) {
			$comp = $match[3];
			if (!isset($comps[$comp])) {
				$comps[$comp]=1;
				$result[] = $match[3];
			}
		}
	}
	return $result;
}

$ptime = 0;
$dirs = array();
$dirs[] = '../classes';
foreach (dirs('../components') as $dir) {
	$dirs[] = "../components/$dir";
}
foreach ($dirs as $dir) {
	foreach (files($dir) as $file) {
		if (substr($file, -4) == '.php') {
			$ptime = max ($ptime, filemtime("$dir/$file"));
		}
	}
}
echo  "<p><font color=gray>Last component or class change was " . elapsed(time()-$ptime) . " ago</font></p>\n";

function status_icon ($pathdir, $file) {
	global $context;
	global $tmp;
	global $ptime;

	$index = "$file.explore";
        $indexpath = "$tmp/$index";
        $want[$index] = 1;
        $rexists = file_exists($indexpath);
        $rsize = $rexists ? filesize($indexpath) : 0;  // write zero length file on error or abort
        $rtime = $rexists ? filemtime($indexpath) : 0;
        $stime = filemtime("$pathdir/$file");
        if (!$rexists || ($rtime < max ($stime, $ptime))) {
                $tiny = 'box';
        } elseif ($rsize == 0) {
                $tiny = 'red-x';
        } else {
                $tiny = 'green-check';
        }
	//echo " [rexists $rexists rsize $rsize rtime $rtime stime $stime ptime $ptime tiny $tiny] ";
        echo "<img src=images/tiny-$tiny.gif> ";
}


$path = 'scripts';
$want = array();
foreach (dirs($path) as $dir) {
	echo "<h2>$dir</h2>\n";
	foreach (files("$path/$dir") as $file) {
                $want["$file.explore"] = 1;
		echo "<li>";
	        echo "<a href=see.php?file=" . urlencode("$dir/$file") . ">see</a>&nbsp;";
	        echo "<a href=run.php?file=" . urlencode("$dir/$file") . ">run</a>";
                status_icon ("$path/$dir", $file);
	        echo "<a href=swim.php?file=" . urlencode("$dir/$file") . ">swim</a> ";
	        echo test_title($file);
		echo "<font color=gray> &nbsp;  ";
		echo count(components_used ( "$path/$dir/$file" )) . " objects ";
		echo elapsed(time()-filemtime("$path/$dir/$file")) . " old ";
		echo "</font>";
	}
}

foreach (files($tmp) as $file) {
        if (substr($file, -8) != '.explore') continue;
	if (isset($want[$file])) continue;
	echo "<li>discarding obsolete index for '$file'";
	unlink ("$tmp/$file");
}


?>
<br><br>
<table width=500><tr><td><font color=gray>
<p>The above scripts are end-to-end use cases that show business processes supported by the
Eclipse Foundation portal. </p>

<p>Each case includes checks that produce results which are indexed and becomes part of the "explore" documentation. See <a href=breakdown.php>Use Case Breakdown</a> for a tabulation of this index. </p>

<p>The status of each case's last run is reported with the following code:
<ul>
<li> <img src=images/tiny-box.gif> result is absent or obsolessed by revised test or new php code
<li> <img src=images/tiny-green-check.gif> result is from test were all checks pass
<li> <img src=images/tiny-red-x.gif> result is from test that failed or found trouble
</ul></p>

<p>Scripts are written in a subset of php using the following functions:
<ul>
<li>login username
<li>refresh
<li>find class, [predicate]
<li>advance time
<br><br>
<li>enter field, value
<li>press button, [value]
<br><br>
<li>check html
<li>omit html
<li>email text, to
</p>

</font></table>
