<?php
$GLOBALS['SKIP_DISABLE_CHECK'] = true;
require_once( "../classes/external_entry_point.php");
external_entry( false );
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
require_once( "../classes/test-context.php");
require_once( "test-functions.php" );

if ($_GET['file']) {
  $file = $_GET['file'];
  $path = "scripts/$file";
} elseif ($argv[1]) {
  $file = $path = $argv[1];
}
?>
<html>
<body>
<link rel="stylesheet" type="text/css" href="images/swim.css">
<script src="../portal/AjaxRequest.js">
</script>
<script language="JavaScript" type="text/javascript">
var timer;
var troubleseen = 0; // client side version of flag
function reportfatalerror() {
	// mark the test as failed
	document.getElementById("headerline").style.backgroundColor = "#ffcfcf";
	document.getElementById("headerline").style.backgroundImage = "url(images/failure.gif)";
}
// start with the test as running
</script>
<h1 id="headerline" style="background-color: #ffffcf; background-image: url(../portal/images/loading.gif); background-position: center right; background-repeat: no-repeat;"><?= test_title($file) ?></h1>
<script language="JavaScript" type="text/javascript">
timer = setTimeout( "reportfatalerror()", 5000); //5 seconds
</script>
<?php

$indexemailbuffer = '';
$indexbuffer = '';
$troubleseen = false; // server side version of flag

function trouble( $string ) {
	global $troubleseen;
	$troubleseen = true;
        echo "<p><table cellpadding=10 width=400 bgcolor=#ffcccc><tr><td><font size=+2>Trouble: </font>";
        echo $string;
        echo "</table></p><script language=\"JavaScript\" type=\"text/javascript\">troubleseen = 1;</script>\n";
}
require_once( "../classes/harness.php" );

echo "<p>";
echo "Edit " . date ("D M d H:i:s T Y", filemtime($path)) . "<br>\n";
//echo "Run " . date ("D M d H:i:s T Y", time()) . "<br>\n";
advance( null );
echo "</p>";

function callback ($buffer) {
  return ($buffer . "end");
}

$context->set("USER", 'nobody');
$lines = file($path);
$number = 0;
$base = basename ($file);
$indexpath = $context->get("indices_directory") . "$base.explore";
$index = fopen($indexpath, 'w');
ftruncate($index, 0); // zero length file means test in progress or failed
fclose($index);
$indexemailpath = $context->get("indices_directory") . "$base.email";
$index = fopen($indexemailpath, 'w');
ftruncate($index, 0); // zero length file means test in progress or failed
fclose($index);

function index ($object, $action) {
  global $context, $file, $number, $indexbuffer;
  $component = $object->component();
  $class = get_class($object);
  $entry = "$file\t$number\t$component\t$class\t$action\n";
  $indexbuffer .= $entry;
}

function index_email ($object, $action) {
  global $context, $file, $number, $indexemailbuffer;
  // echo "<li> email: $number -- $action<br>\n";
  $parts = explode ("/", $action);
  $action = array_pop ($parts);
  if ($object !== false) {
	$component = $object->component();
	$class = get_class($object);
  } else {
	$component = 'DailyActivity';
	$class = 'DailyActivity';
  }
  $entry = "$file\t$number\t$component\t$class\t$action\n";
  $indexemailbuffer .= $entry;
}

?>
<script language="JavaScript" type="text/javascript">
clearTimeout(timer);
</script>
<?php
foreach ($lines as $line) {
  $number++;
?>
<font color=gray><?= $number ?>: <?= htmlspecialchars($line) ?></font><br>
<script language="JavaScript" type="text/javascript">
timer = setTimeout( "reportfatalerror()", 1300); //1.3 seconds
</script>
<?php
  ob_start();
  $error=false;
  // $result = eval(try {$line} catch (Exception \$e) {\$error = \$e.getMessage();}; true");
  $result = eval($line);
  $html=ob_get_contents();
  ob_end_clean();
  $html = sanitize_images_in_html( $html );
  echo $html;
  if ($error) trouble($error);
  if( $result === false ) {
    trouble("Can't parse test statement. Check for unescaped punctuation, e.g., ' \", mismatched parentheses, etc. $html");
  }
  if ($html) $current_html = $html;
  trace_buffer_flush();
  immediate_email_cron();  // we now do this after every step to get more accurate indexing
?>
<script language="JavaScript" type="text/javascript">
clearTimeout(timer);
</script>
<?php
}
?>
<p><font color=gray>end of input</font></p>
<?php

complete();
?>
<script language="JavaScript" type="text/javascript">
if( troubleseen ) {
    // mark the test as failed
    document.getElementById("headerline").style.backgroundColor = "#ffcfcf";
    document.getElementById("headerline").style.backgroundImage = "url(images/failure.gif)";
} else {
    // mark the test as passed
    document.getElementById("headerline").style.backgroundColor = "#cfffcf";
    document.getElementById("headerline").style.backgroundImage = "url(images/success.gif)";
}
</script>
<?php
if (!$troubleseen) {
	$index = fopen($indexpath, 'w');
        fwrite($index, $indexbuffer);
        fwrite($index, "end-of-input"); // make non-zero in empty $indexbuffer case
        fclose($index);
        $index = fopen($indexemailpath, 'w');
        fwrite($index, $indexemailbuffer);
        fwrite($index, "end-of-input"); // make non-zero in empty $indexbuffer case
        fclose($index);
	echo "<!-- Test Passed -->\n"; // all.pl looks for this text
}
/* Potentially because we're switching to an in-memory test database, the data will be lost as
 * soon as the test is over; thus we need to dump the database into an HTML file so that we can inspect it later.
 * So far the "ENGINE=Memory means data not retained" doesn't seem to be true on Bjorn's local dev
 * machine, which is puzzling...
 */
?>
</body>
</html>
